## docker.io 20.10.23+dfsg1

=== engine/Makefile ===
.PHONY: all binary dynbinary build cross help install manpages run shell test test-docker-py test-integration test-unit validate win

BUILDX_VERSION ?= v0.8.2

ifdef USE_BUILDX
BUILDX ?= $(shell command -v buildx)
BUILDX ?= $(shell command -v docker-buildx)
DOCKER_BUILDX_CLI_PLUGIN_PATH ?= ~/.docker/cli-plugins/docker-buildx
BUILDX ?= $(shell if [ -x "$(DOCKER_BUILDX_CLI_PLUGIN_PATH)" ]; then echo $(DOCKER_BUILDX_CLI_PLUGIN_PATH); fi)
endif

ifndef USE_BUILDX
DOCKER_BUILDKIT := 1
export DOCKER_BUILDKIT
endif

BUILDX ?= bundles/buildx
DOCKER ?= docker

# set the graph driver as the current graphdriver if not set
DOCKER_GRAPHDRIVER := $(if $(DOCKER_GRAPHDRIVER),$(DOCKER_GRAPHDRIVER),$(shell docker info 2>&1 | grep "Storage Driver" | sed 's/.*: //'))
export DOCKER_GRAPHDRIVER

# get OS/Arch of docker engine
DOCKER_OSARCH := $(shell bash -c 'source hack/make/.detect-daemon-osarch && echo $${DOCKER_ENGINE_OSARCH}')
DOCKERFILE := $(shell bash -c 'source hack/make/.detect-daemon-osarch && echo $${DOCKERFILE}')

DOCKER_GITCOMMIT := $(shell git rev-parse --short HEAD || echo unsupported)
export DOCKER_GITCOMMIT

# allow overriding the repository and branch that validation scripts are running
# against these are used in hack/validate/.validate to check what changed in the PR.
export VALIDATE_REPO
export VALIDATE_BRANCH
export VALIDATE_ORIGIN_BRANCH

# env vars passed through directly to Docker's build scripts
# to allow things like `make KEEPBUNDLE=1 binary` easily
# `project/PACKAGERS.md` have some limited documentation of some of these
#
# DOCKER_LDFLAGS can be used to pass additional parameters to -ldflags
# option of "go build". For example, a built-in graphdriver priority list
# can be changed during build time like this:
#
# make DOCKER_LDFLAGS="-X github.com/docker/docker/daemon/graphdriver.priority=overlay2,devicemapper" dynbinary
#
DOCKER_ENVS := \
	-e DOCKER_CROSSPLATFORMS \
	-e BUILD_APT_MIRROR \
	-e BUILDFLAGS \
	-e KEEPBUNDLE \
	-e DOCKER_BUILD_ARGS \
	-e DOCKER_BUILD_GOGC \
	-e DOCKER_BUILD_OPTS \
	-e DOCKER_BUILD_PKGS \
	-e DOCKER_BUILDKIT \
	-e DOCKER_BASH_COMPLETION_PATH \
	-e DOCKER_CLI_PATH \
	-e DOCKER_DEBUG \
	-e DOCKER_EXPERIMENTAL \
	-e DOCKER_GITCOMMIT \
	-e DOCKER_GRAPHDRIVER \
	-e DOCKER_LDFLAGS \
	-e DOCKER_PORT \
	-e DOCKER_REMAP_ROOT \
	-e DOCKER_ROOTLESS \
	-e DOCKER_STORAGE_OPTS \
	-e DOCKER_TEST_HOST \
	-e DOCKER_USERLANDPROXY \
	-e DOCKERD_ARGS \
	-e TEST_FORCE_VALIDATE \
	-e TEST_INTEGRATION_DIR \
	-e TEST_SKIP_INTEGRATION \
	-e TEST_SKIP_INTEGRATION_CLI \
	-e TESTDEBUG \
	-e TESTDIRS \
	-e TESTFLAGS \
	-e TESTFLAGS_INTEGRATION \
	-e TESTFLAGS_INTEGRATION_CLI \
	-e TEST_FILTER \
	-e TIMEOUT \
	-e VALIDATE_REPO \
	-e VALIDATE_BRANCH \
	-e VALIDATE_ORIGIN_BRANCH \
	-e HTTP_PROXY \
	-e HTTPS_PROXY \
	-e NO_PROXY \
	-e http_proxy \
	-e https_proxy \
	-e no_proxy \
	-e VERSION \
	-e PLATFORM \
	-e DEFAULT_PRODUCT_LICENSE \
	-e PRODUCT
# note: we _cannot_ add "-e DOCKER_BUILDTAGS" here because even if it's unset in the shell, that would shadow the "ENV DOCKER_BUILDTAGS" set in our Dockerfile, which is very important for our official builds

# to allow `make BIND_DIR=. shell` or `make BIND_DIR= test`
# (default to no bind mount if DOCKER_HOST is set)
# note: BINDDIR is supported for backwards-compatibility here
BIND_DIR := $(if $(BINDDIR),$(BINDDIR),$(if $(DOCKER_HOST),,bundles))

# DOCKER_MOUNT can be overriden, but use at your own risk!
ifndef DOCKER_MOUNT
DOCKER_MOUNT := $(if $(BIND_DIR),-v "$(CURDIR)/$(BIND_DIR):/go/src/github.com/docker/docker/$(BIND_DIR)")
DOCKER_MOUNT := $(if $(DOCKER_BINDDIR_MOUNT_OPTS),$(DOCKER_MOUNT):$(DOCKER_BINDDIR_MOUNT_OPTS),$(DOCKER_MOUNT))

# This allows the test suite to be able to run without worrying about the underlying fs used by the container running the daemon (e.g. aufs-on-aufs), so long as the host running the container is running a supported fs.
# The volume will be cleaned up when the container is removed due to `--rm`.
# Note that `BIND_DIR` will already be set to `bundles` if `DOCKER_HOST` is not set (see above BIND_DIR line), in such case this will do nothing since `DOCKER_MOUNT` will already be set.
DOCKER_MOUNT := $(if $(DOCKER_MOUNT),$(DOCKER_MOUNT),-v /go/src/github.com/docker/docker/bundles) -v "$(CURDIR)/.git:/go/src/github.com/docker/docker/.git"

DOCKER_MOUNT_CACHE := -v docker-dev-cache:/root/.cache
DOCKER_MOUNT_CLI := $(if $(DOCKER_CLI_PATH),-v $(shell dirname $(DOCKER_CLI_PATH)):/usr/local/cli,)
DOCKER_MOUNT_BASH_COMPLETION := $(if $(DOCKER_BASH_COMPLETION_PATH),-v $(shell dirname $(DOCKER_BASH_COMPLETION_PATH)):/usr/local/completion/bash,)
DOCKER_MOUNT := $(DOCKER_MOUNT) $(DOCKER_MOUNT_CACHE) $(DOCKER_MOUNT_CLI) $(DOCKER_MOUNT_BASH_COMPLETION)
endif # ifndef DOCKER_MOUNT

# This allows to set the docker-dev container name
DOCKER_CONTAINER_NAME := $(if $(CONTAINER_NAME),--name $(CONTAINER_NAME),)

GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN := $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
DOCKER_IMAGE := docker-dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
DOCKER_PORT_FORWARD := $(if $(DOCKER_PORT),-p "$(DOCKER_PORT)",)

DOCKER_FLAGS := $(DOCKER) run --rm -i --privileged $(DOCKER_CONTAINER_NAME) $(DOCKER_ENVS) $(DOCKER_MOUNT) $(DOCKER_PORT_FORWARD)
BUILD_APT_MIRROR := $(if $(DOCKER_BUILD_APT_MIRROR),--build-arg APT_MIRROR=$(DOCKER_BUILD_APT_MIRROR))
export BUILD_APT_MIRROR

SWAGGER_DOCS_PORT ?= 9000

define \n


endef

# if this session isn't interactive, then we don't want to allocate a
# TTY, which would fail, but if it is interactive, we do want to attach
# so that the user can send e.g. ^C through.
INTERACTIVE := $(shell [ -t 0 ] && echo 1 || echo 0)
ifeq ($(INTERACTIVE), 1)
	DOCKER_FLAGS += -t
endif

DOCKER_RUN_DOCKER := $(DOCKER_FLAGS) "$(DOCKER_IMAGE)"

DOCKER_BUILD_ARGS += --build-arg=GO_VERSION
ifdef DOCKER_SYSTEMD
DOCKER_BUILD_ARGS += --build-arg=SYSTEMD=true
endif

BUILD_OPTS := ${BUILD_APT_MIRROR} ${DOCKER_BUILD_ARGS} ${DOCKER_BUILD_OPTS} -f "$(DOCKERFILE)"
ifdef USE_BUILDX
BUILD_OPTS += $(BUILDX_BUILD_EXTRA_OPTS)
BUILD_CMD := $(BUILDX) build
else
BUILD_CMD := $(DOCKER) build
endif

# This is used for the legacy "build" target and anything still depending on it
BUILD_CROSS =
ifdef DOCKER_CROSS
BUILD_CROSS = --build-arg CROSS=$(DOCKER_CROSS)
endif
ifdef DOCKER_CROSSPLATFORMS
BUILD_CROSS = --build-arg CROSS=true
endif

VERSION_AUTOGEN_ARGS = --build-arg VERSION --build-arg DOCKER_GITCOMMIT --build-arg PRODUCT --build-arg PLATFORM --build-arg DEFAULT_PRODUCT_LICENSE

default: binary

all: build ## validate all checks, build linux binaries, run all tests,\ncross build non-linux binaries, and generate archives
	$(DOCKER_RUN_DOCKER) bash -c 'hack/validate/default && hack/make.sh'

# This is only used to work around read-only bind mounts of the source code into
# binary build targets. We end up mounting a tmpfs over autogen which allows us
# to write build-time generated assets even though the source is mounted read-only
# ...But in order to do so, this dir needs to already exist.
autogen:
	mkdir -p autogen

binary: buildx autogen ## build statically linked linux binaries
	$(BUILD_CMD) $(BUILD_OPTS) --output=bundles/ --target=$@ $(VERSION_AUTOGEN_ARGS) .

dynbinary: buildx autogen ## build dynamically linked linux binaries
	$(BUILD_CMD) $(BUILD_OPTS) --output=bundles/ --target=$@ $(VERSION_AUTOGEN_ARGS) .

cross: BUILD_OPTS += --build-arg CROSS=true --build-arg DOCKER_CROSSPLATFORMS
cross: buildx autogen ## cross build the binaries for darwin, freebsd and\nwindows
	$(BUILD_CMD) $(BUILD_OPTS) --output=bundles/ --target=$@ $(VERSION_AUTOGEN_ARGS) .

bundles:
	mkdir bundles

.PHONY: clean
clean: clean-cache

.PHONY: clean-cache
clean-cache:
	docker volume rm -f docker-dev-cache

help: ## this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {gsub("\\\\n",sprintf("\n%22c",""), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

install: ## install the linux binaries
	KEEPBUNDLE=1 hack/make.sh install-binary

run: build ## run the docker daemon in a container
	$(DOCKER_RUN_DOCKER) sh -c "KEEPBUNDLE=1 hack/make.sh install-binary run"
 
.PHONY: build
ifeq ($(BIND_DIR), .)
build: shell_target := --target=dev
else
build: shell_target := --target=final
endif
ifdef USE_BUILDX
build: buildx_load := --load
endif
build: buildx
	$(BUILD_CMD) $(BUILD_OPTS) $(shell_target) $(buildx_load) $(BUILD_CROSS) -t "$(DOCKER_IMAGE)" .

shell: build  ## start a shell inside the build env
	$(DOCKER_RUN_DOCKER) bash

test: build test-unit ## run the unit, integration and docker-py tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary cross test-integration test-docker-py

test-docker-py: build ## run the docker-py tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-docker-py

test-integration-cli: test-integration ## (DEPRECATED) use test-integration

ifneq ($(and $(TEST_SKIP_INTEGRATION),$(TEST_SKIP_INTEGRATION_CLI)),)
test-integration:
	@echo Both integrations suites skipped per environment variables
else
test-integration: build ## run the integration tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration
endif

test-integration-flaky: build ## run the stress test for all new integration tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration-flaky

test-unit: build ## run the unit tests
	$(DOCKER_RUN_DOCKER) hack/test/unit

validate: build ## validate DCO, Seccomp profile generation, gofmt,\n./pkg/ isolation, golint, tests, tomls, go vet and vendor
	$(DOCKER_RUN_DOCKER) hack/validate/all

win: build ## cross build the binary for windows
	$(DOCKER_RUN_DOCKER) DOCKER_CROSSPLATFORMS=windows/amd64 hack/make.sh cross

.PHONY: swagger-gen
swagger-gen:
	docker run --rm -v $(PWD):/go/src/github.com/docker/docker \
		-w /go/src/github.com/docker/docker \
		--entrypoint hack/generate-swagger-api.sh \
		-e GOPATH=/go \
		quay.io/goswagger/swagger:0.7.4

.PHONY: swagger-docs
swagger-docs: ## preview the API documentation
	@echo "API docs preview will be running at http://localhost:$(SWAGGER_DOCS_PORT)"
	@docker run --rm -v $(PWD)/api/swagger.yaml:/usr/share/nginx/html/swagger.yaml \
		-e 'REDOC_OPTIONS=hide-hostname="true" lazy-rendering' \
		-p $(SWAGGER_DOCS_PORT):80 \
		bfirsh/redoc:1.6.2

.PHONY: buildx
ifdef USE_BUILDX
ifeq ($(BUILDX), bundles/buildx)
buildx: bundles/buildx ## build buildx cli tool
endif
endif

bundles/buildx: bundles ## build buildx CLI tool
	curl -fsSL https://raw.githubusercontent.com/moby/buildkit/70deac12b5857a1aa4da65e90b262368e2f71500/hack/install-buildx | VERSION="$(BUILDX_VERSION)" BINDIR="$(@D)" bash
	$@ version

=== design/tla/Makefile ===
WORKERS := 4

TLA := docker run --rm -it --workdir /mnt -v ${PWD}:/mnt talex5/tla

.PHONY: all check pdfs tlaps

all: check pdfs tlaps

# Run the TLC model checker
check:
	${TLA} tlc -workers ${WORKERS} SwarmKit.tla -config models/SwarmKit.cfg
	${TLA} tlc -workers ${WORKERS} WorkerImpl.tla -config models/WorkerImpl.cfg

# Run the TLAPS proof checker
tlaps:
	${TLA} tlapm -I /usr/local/lib/tlaps SwarmKit.tla
	${TLA} tlapm -I /usr/local/lib/tlaps WorkerImpl.tla

# Generate a PDF file from a .tla file
%.pdf: %.tla
	[ -d metadir ] || mkdir metadir
	${TLA} java tla2tex.TLA -shade -latexCommand pdflatex -latexOutputExt pdf -metadir metadir $<

pdfs: SwarmKit.pdf Types.pdf Tasks.pdf WorkerSpec.pdf EventCounter.pdf

=== debian/changelog ===
docker.io (20.10.23+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release [20.10.23]
  * Drop merged btrfs-progs 6.1 patch

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 20 Jan 2023 16:04:03 +0800

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Standards-Version: 4.6.0
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Arnaud Rebillout <arnaudr@kali.org>
          ,Dmitry Smirnov <onlyjob@debian.org>
          ,Tim Potter <tpot@hpe.com>
          ,Tianon Gravi <tianon@debian.org>
          ,Paul Tagliamonte <paultag@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: debhelper-compat (= 13) ,dh-apparmor ,dh-golang (>= 1.14~)
    ,bash-completion
    ,ca-certificates
    ,golang-any (>= 2:1.10~)
    ,go-md2man (>= 1.0.3~)
    ,gogoprotobuf, libprotobuf-dev
    ,golang-dbus-dev (>= 5.0.2~)
#    ,golang-etcd-server-dev
    ,golang-github-armon-circbuf-dev
    ,golang-github-armon-go-metrics-dev
    ,golang-github-aws-aws-sdk-go-dev
    ,golang-github-bsphere-le-go-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-cespare-xxhash-dev
    ,golang-github-cilium-ebpf-dev
    ,golang-github-cloudflare-cfssl-dev
    ,golang-github-containerd-cgroups-dev
    ,golang-github-containerd-console-dev
    ,golang-github-containerd-containerd-dev (>= 1.4.2~ds1-2~)
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-containerd-fifo-dev
    ,golang-github-containerd-go-runc-dev
    ,golang-github-containerd-typeurl-dev
    ,golang-github-coreos-bbolt-dev
    ,golang-github-coreos-go-systemd-dev (>= 20~)
    ,golang-github-creack-pty-dev
    ,golang-github-cyphar-filepath-securejoin-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-events-dev
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-libtrust-dev
    ,golang-github-docker-notary-dev
    ,golang-github-fernet-fernet-go-dev
    ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-fvbommel-sortorder-dev
    ,golang-github-gofrs-flock-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-golang-groupcache-dev
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-google-go-cmp-dev (>= 0.2.0~)
    ,golang-github-google-shlex-dev
    ,golang-github-google-uuid-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-gotestyourself-gotest.tools-dev
    ,golang-github-graylog2-go-gelf-dev (>= 0.0+git20191017~)
    ,golang-github-grpc-ecosystem-go-grpc-prometheus-dev
    ,golang-github-grpc-ecosystem-go-grpc-middleware-dev
    ,golang-github-grpc-ecosystem-grpc-opentracing-dev
    ,golang-github-hashicorp-go-memdb-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-imdario-mergo-dev (>= 0.3.3~)
    ,golang-github-json-iterator-go-dev (>= 1.1.4~)
    ,golang-github-miekg-dns-dev (>= 1.1.26~)
    ,golang-github-mitchellh-hashstructure-dev
    ,golang-github-moby-locker-dev
    ,golang-github-moby-sys-dev
    ,golang-github-moby-term-dev
    ,golang-github-modern-go-reflect2-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
    ,golang-github-opentracing-contrib-go-stdlib-dev
    ,golang-github-opentracing-opentracing-go-dev
    ,golang-github-philhofer-fwd-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-racksec-srslog-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-spf13-cobra-dev (>= 1.1.1~)
    ,golang-github-spf13-pflag-dev (>= 1.0.5-2~)
    ,golang-github-tchap-go-patricia-dev
#    ,golang-github-tonistiigi-fsutil-dev (>= 0.0~git20200724~)
    ,golang-github-tonistiigi-units-dev
    ,golang-github-urfave-cli-dev (>= 1.20.0~)
    ,golang-github-vbatts-tar-split-dev (>= 0.11.1~)
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev (>= 0.0~git20170707~)
    ,golang-github-xeipuuv-gojsonschema-dev (>= 1.2.0~)
    ,golang-gocapability-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-google-dev | golang-golang-x-oauth2-dev
    ,golang-golang-x-term-dev
    ,golang-golang-x-time-dev
    ,golang-google-api-dev
    ,golang-google-cloud-dev
    ,golang-google-grpc-dev
    ,golang-goprotobuf-dev (>= 0.0~git20151207~)
    ,golang-go-zfs-dev
    ,golang-protobuf-extensions-dev
    ,gotestsum
    ,libapparmor-dev
    ,libbtrfs-dev | btrfs-progs (<< 4.16.1~)
    ,libdevmapper-dev
    ,libseccomp-dev
    ,pkg-config
    ,procps
    ,tzdata
# tests:
    ,git
# swarmkit tests are not run:
#   ,golang-github-onsi-ginkgo-dev
#   ,golang-gomega-dev
# cli/vendor/k8s.io dependencies:
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-evanphx-json-patch-dev (>= 4.1.0~)
    ,golang-github-googleapis-gnostic-dev
    ,golang-github-google-gofuzz-dev
    ,golang-gopkg-inf.v0-dev
#   ,golang-k8s-sigs-structured-merge-diff-dev
    ,golang-k8s-sigs-yaml-dev
Homepage: https://mobyproject.org
Vcs-Browser: https://salsa.debian.org/go-team/packages/docker
Vcs-Git: https://salsa.debian.org/go-team/packages/docker.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends} ,${shlibs:Depends}
    ,adduser
    ,containerd (>= 1.4~)
    ,iptables
    ,lsb-base
    ,runc (>= 1.0.0~rc8~)
    ,tini
Recommends: apparmor
    ,ca-certificates
    ,cgroupfs-mount
    ,git
    ,needrestart (>= 3.1~)
    ,xz-utils
Conflicts:
## Docker's vendor packages:
    docker-ce
    ,docker-ce-cli
    ,docker-ce-rootless-extras
Suggests: docker-doc
    ,aufs-tools
    ,btrfs-progs
    ,debootstrap
    ,e2fsprogs
    ,rinse
    ,rootlesskit
    ,xfsprogs
    ,zfs-fuse | zfsutils-linux
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: golang-github-docker-docker-dev
Architecture: all
Section: golang
Depends: ${misc:Depends}
    ,golang-github-armon-circbuf-dev
    ,golang-github-containerd-containerd-dev (>= 1.4.2~ds1-2~)
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-moby-term-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-tchap-go-patricia-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev (>= 0.0~git20190726~)
    ,golang-google-grpc-dev
# libnetwork:
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-github-burntsushi-toml-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-go-events-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev
# moby/buildkit/session
    ,golang-github-opentracing-opentracing-go-dev
Description: reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

## docker.io 20.10.24+dfsg1

=== Makefile ===
.PHONY: all all-local build build-local clean cross cross-local vet lint misspell check check-local check-code check-format unit-tests protobuf protobuf-local check-protobuf
SHELL=/bin/bash

dockerbuildargs ?= --target dev - < Dockerfile
dockerargs ?= --privileged -v $(shell pwd):/go/src/github.com/docker/libnetwork -w /go/src/github.com/docker/libnetwork
build_image=libnetworkbuild
container_env = -e "INSIDECONTAINER=-incontainer=true"
docker = docker run --rm -it --init ${dockerargs} $$EXTRA_ARGS ${container_env} ${build_image}

CROSS_PLATFORMS = linux/amd64 linux/386 linux/arm windows/amd64
PACKAGES=$(shell go list ./... | grep -v /vendor/)
PROTOC_FLAGS=-I=. -I=/go/src -I=/go/src/github.com/gogo/protobuf -I=/go/src/github.com/gogo/protobuf/protobuf

export PATH := $(CURDIR)/bin:$(PATH)


# Several targets in this Makefile expect to run within the
# libnetworkbuild container.   In general, a target named '<target>-local'
# relies on utilities inside the build container.   Usually there is also
# a wrapper called '<target>' which starts a container and runs
# 'make <target>-local' inside it.

###########################################################################
# Top level targets
###########################################################################

all: build check clean

all-local: build-local check-local clean


###########################################################################
# Build targets
###########################################################################

# builder builds the libnetworkbuild container.  All wrapper targets
# must depend on this to ensure that the container exists.
builder:
	DOCKER_BUILDKIT=1 docker build --progress=plain  -t ${build_image} --build-arg=GO_VERSION ${dockerbuildargs}

build: builder
	@echo "🐳 $@"
	@${docker} make build-local

build-local:
	@echo "🐳 $@"
	@mkdir -p "bin"
	GO111MODULE=off go build -tags experimental -o "bin/dnet" ./cmd/dnet
	GO111MODULE=off go build -o "bin/docker-proxy" ./cmd/proxy
	CGO_ENABLED=0 go build -o "bin/diagnosticClient" ./cmd/diagnostic
	CGO_ENABLED=0 go build -o "bin/testMain" ./cmd/networkdb-test/testMain.go

build-images:
	@echo "🐳 $@"
	cp cmd/diagnostic/daemon.json ./bin
	DOCKER_BUILDKIT=1 docker build --progress=plain  -f cmd/diagnostic/Dockerfile.client -t dockereng/network-diagnostic:onlyclient bin/
	DOCKER_BUILDKIT=1 docker build --progress=plain  -f cmd/diagnostic/Dockerfile.dind -t dockereng/network-diagnostic:17.12-dind bin/
	DOCKER_BUILDKIT=1 docker build --progress=plain  -f cmd/networkdb-test/Dockerfile -t dockereng/e2e-networkdb:master bin/
	DOCKER_BUILDKIT=1 docker build --progress=plain  -t dockereng/network-diagnostic:support.sh support/

push-images: build-images
	@echo "🐳 $@"
	docker push dockereng/network-diagnostic:onlyclient
	docker push dockereng/network-diagnostic:17.12-dind
	docker push dockereng/e2e-networkdb:master
	docker push dockereng/network-diagnostic:support.sh

clean:
	@echo "🐳 $@"
	@if [ -d bin ]; then \
		echo "Removing binaries"; \
		rm -rf bin; \
	fi

cross: builder
	@mkdir -p "bin"
	@for platform in ${CROSS_PLATFORMS}; do \
		EXTRA_ARGS="-e GOOS=$${platform%/*} -e GOARCH=$${platform##*/}" ; \
		echo "$${platform}..." ; \
		${docker} make cross-local ; \
	done

cross-local:
	@echo "🐳 $@"
	GO111MODULE=off go build -o "bin/dnet-$$GOOS-$$GOARCH" ./cmd/dnet
	GO111MODULE=off go build -o "bin/docker-proxy-$$GOOS-$$GOARCH" ./cmd/proxy

# Rebuild protocol buffers.
# These may need to be rebuilt after vendoring updates, so .proto files are declared .PHONY so they are always rebuilt.
PROTO_FILES=$(shell find . -path ./vendor -prune -o -name \*.proto -print)
PB_FILES=$(PROTO_FILES:.proto=.pb.go)

# Pattern rule for protoc.   If PROTOC_CHECK is defined, it checks
# whether the generated files are up to date and fails if they are not
%.pb.go: %.proto
	@if [ ${PROTOC_CHECK} ]; then \
	protoc ${PROTOC_FLAGS} --gogo_out=/tmp $< ; \
	diff -q $@ /tmp/$@ >/dev/null || (echo "👹 $@ is out of date; please run 'make protobuf' and check in updates" && exit 1) ; \
	else \
	protoc ${PROTOC_FLAGS} --gogo_out=./ $< ; \
	fi

.PHONY: $(PROTO_FILES)
protobuf: builder
	@${docker} make protobuf-local
protobuf-local: $(PB_FILES)


###########################################################################
# Test targets
###########################################################################

check: builder
	@${docker} make check-local

check-local: check-code check-format

check-code: check-protobuf lint vet ineffassign

check-format: fmt misspell

unit-tests: builder
	${docker} make unit-tests-local

unit-tests-local:
	@echo "🐳 Running tests... "
	@echo "mode: count" > coverage.coverprofile
	@GO111MODULE=off go build -o "bin/docker-proxy" ./cmd/proxy
	@for dir in $$( find . -maxdepth 10 -not -path './.git*' -not -path '*/_*' -not -path './vendor/*' -type d); do \
	if ls $$dir/*.go &> /dev/null; then \
		pushd . &> /dev/null ; \
		cd $$dir ; \
		go test ${INSIDECONTAINER} -test.parallel 5 -test.v -covermode=count -coverprofile=./profile.tmp ; \
		ret=$$? ;\
		if [ $$ret -ne 0 ]; then exit $$ret; fi ;\
		popd &> /dev/null; \
		if [ -f $$dir/profile.tmp ]; then \
			cat $$dir/profile.tmp | tail -n +2 >> coverage.coverprofile ; \
				rm $$dir/profile.tmp ; \
	    fi ; \
	fi ; \
	done
	@echo "Done running tests"

# Depends on binaries because vet will silently fail if it can not load compiled imports
vet: ## run go vet
	@echo "🐳 $@"
	@test -z "$$(go vet ${PACKAGES} 2>&1 | grep -v 'constant [0-9]* not a string in call to Errorf' | egrep -v '(timestamp_test.go|duration_test.go|exit status 1)' | tee /dev/stderr)"

misspell:
	@echo "🐳 $@"
	@test -z "$$(find . -type f | grep -v vendor/ | grep "\.go\|\.md" | xargs misspell -error | tee /dev/stderr)"

fmt: ## run go fmt
	@echo "🐳 $@"
	@test -z "$$(gofmt -s -l . | grep -v vendor/ | grep -v ".pb.go$$" | tee /dev/stderr)" || \
		(echo "👹 please format Go code with 'gofmt -s -w'" && false)

lint: ## run go lint
	@echo "🐳 $@"
	@test -z "$$(golint ./... | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

ineffassign: ## run ineffassign
	@echo "🐳 $@"
	@test -z "$$(ineffassign . | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

# check-protobuf rebuilds .pb.go files and fails if they have changed
check-protobuf: PROTOC_CHECK=1
check-protobuf: $(PB_FILES)
	@echo "🐳 $@"


###########################################################################
# Utility targets
###########################################################################

shell: builder
	@${docker} ${SHELL}

=== debian/changelog ===
docker.io (20.10.24+dfsg1-1ubuntu2) mantic; urgency=medium

  * d/p/test--skip-daemon-oci-linux-pbuilder-tests.patch: always skip engine
    test TestGetSourceMount which is failing in LP. The Debian maintainer
    already skipped this test when the package is built with pbuilder, now
    this condition has been removed and the test is always skipped.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 06 Jun 2023 21:29:06 -0300

docker.io (20.10.24+dfsg1-1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable (LP: #2022390, #1946376). Make src:docker.io
    follow Debian and src:docker.io-app is going to ship the application and
    documentation with vendorized dependencies so we can keep updating just the
    application across all supported releases.
  * Added changes:
    - d/control: remove binary paragraghs for docker.io and docker-doc.
    - d/docker-doc.docs: removed together with the docker-doc binary package.
    - d/docker.io.*: remove all packaging related files associated to the
      docker.io binary package.
    - d/p/engine-allow-exclude-unit-test.patch: add patch to allow excluding
      extra directories when running engine unit tests.
    - d/rules:
      + Do not run aufs related unit tests in the engine component.
      + Do not install apparmor profile for docker.io.
      + remove override_dh_gencontrol, since docker.io binary package was also
        removed.
    - d/tests: remove since all tests are related to the docker application
      provided by docker.io binary package.
    - d/golang-github-docker-docker-dev.docs: install NOTICE files to comply
      with Apache license.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 02 Jun 2023 16:06:10 -0300

docker.io (20.10.24+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release [20.10.24]
    + CVE-2023-28840: Encrypted overlay network may be unauthenticated
    + CVE-2023-28841: Encrypted overlay network traffic may be unencrypted
    + CVE-2023-28842: Encrypted overlay network with a single endpoint is
      unauthenticated
  * Bump golang-github-containerd-fifo-dev to 1.1.0. Fix potential panic.

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 05 Apr 2023 23:19:59 +0800

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg1,\
repack,compression=xz,\
dversionmangle=auto,\
uversionmangle=s{(\d)[\-]?((rc|beta)\d*)$}{$1~$2},\
" https://github.com/moby/moby/tags \
  archive/refs/tags/v(\d\S*)\.tar\.gz debian ./debian/get-orig-source.sh

## docker.io 20.10.25%2Bdfsg1

=== debian/changelog ===
docker.io (20.10.25+dfsg1-2deepin1) unstable; urgency=medium

  * fix: DM - skip test for pbuilder and OBS: Can't find mount point of /.

 -- LiChengGang <lichenggang@uniontech.com>  Tue, 23 Apr 2024 18:08:51 +0800

docker.io (20.10.25+dfsg1-2) unstable; urgency=medium

  * Backport https://github.com/moby/buildkit/pull/3104 to fix FTBFS (due to
    updated opencontainers/image-spec)

 -- Tianon Gravi <tianon@debian.org>  Fri, 22 Sep 2023 16:09:48 -0700

docker.io (20.10.25+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release [20.10.25]
  * Backport patch to fix building with Go 1.20.6 (Closes: #1041254)

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 17 Jul 2023 16:24:02 +0800

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
     ,golang-github-containerd-console-dev
     ,golang-github-containerd-containerd-dev (>= 1.4.2~ds1-2~)
     ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
-    ,golang-github-containerd-fifo-dev
+    ,golang-github-containerd-fifo-dev (>= 1.1.0~)
     ,golang-github-containerd-go-runc-dev
     ,golang-github-containerd-typeurl-dev
     ,golang-github-coreos-bbolt-dev

## docker.io 20.10.25+dfsg1

=== Makefile ===
# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

PROJECT_ROOT=github.com/docker/swarmkit

SHELL := /bin/bash

# stop here. do we want to run everything inside of a container, or do we want
# to run it directly on the host? if the user has set ANY non-empty value for
# the variable DOCKER_SWARMKIT_USE_CONTAINER, then we do all of the making
# inside of a container. We will default to using no container, to avoid
# breaking anyone's workflow
ifdef DOCKER_SWARMKIT_USE_CONTAINER
include containerized.mk
else
include direct.mk
endif

=== debian/changelog ===
docker.io (20.10.25+dfsg1-2ubuntu1.24.04.1) noble-security; urgency=medium

  [ Vyom Yadav ]
  * Fix loopclosure test bugs and make off-by-one error a feature
    - debian/patches/test--fix-xfer-TestMaxDownloadAttempts.patch:
      Fix loopclosure bug in xfer/download_test.go and
      integration/build/build_test.go, change test result to make
      off-by-one --max-download-attempts error a feature.

  [ Evan Caville ]
  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Fri, 18 Jul 2025 09:19:54 +1000

docker.io (20.10.25+dfsg1-2ubuntu1) noble; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control: remove binary paragraghs for docker.io and docker-doc.
    - d/docker-doc.docs: removed together with the docker-doc binary package.
    - d/docker.io.*: remove all packaging related files associated to the
      docker.io binary package.
    - d/p/engine-allow-exclude-unit-test.patch: add patch to allow excluding
      extra directories when running engine unit tests.
    - d/rules:
      + Do not run aufs related unit tests in the engine component.
      + Do not install apparmor profile for docker.io.
      + remove override_dh_gencontrol, since docker.io binary package was also
        removed.
    - d/tests: remove since all tests are related to the docker application
      provided by docker.io binary package.
    - d/golang-github-docker-docker-dev.docs: install NOTICE files to comply
      with Apache license.
    - d/p/test--skip-daemon-oci-linux-pbuilder-tests.patch: always skip engine
      test TestGetSourceMount which is failing in LP. The Debian maintainer
      already skipped this test when the package is built with pbuilder, now
      this condition has been removed and the test is always skipped.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 15 Jan 2024 17:08:38 -0300

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# The engine is built and tested using upstream scripts
# and Makefiles, rather than dh_auto_*. Therefore we can't rely
# on dh to set the environment for us, we have to do it here.
export GOPATH := $(CURDIR)/_build
export GOCACHE := $(GOPATH)/go-build
export GO111MODULE := off
export GOPROXY := off

#export DH_GOLANG_BUILDPKG := github.com/docker/docker github.com/docker/cli
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA := testdata/
export DH_GOLANG_EXCLUDES := \
    integration-cli \
    overlay_test \
    vendor

# Package names
CLI_PKG        := github.com/docker/cli
ENGINE_PKG     := github.com/docker/docker
LIBNETWORK_PKG := github.com/docker/libnetwork
SWARMKIT_PKG   := github.com/docker/swarmkit

# Version and commits
DOCKER_VERSION := $(DEB_VERSION_UPSTREAM)
ENGINE_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh engine $(DOCKER_VERSION))
ifndef ENGINE_GITCOMMIT
  $(error Missing ENGINE_GITCOMMIT - see debian/helpers/engine-gitcommits)
endif
CLI_GITCOMMIT    := $(shell ./debian/helpers/gitcommit.sh cli $(DOCKER_VERSION))
ifndef CLI_GITCOMMIT
  $(error Missing CLI_GITCOMMIT - see debian/helpers/cli-gitcommits)
endif

# Cf. scripts/build/binary scripts/build/.variables
CLI_BUILDTIME := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" +"%Y-%m-%dT%H:%M:%SZ")
CLI_BUILDTAGS := pkcs11
CLI_LDFLAGS   += -X $(CLI_PKG)/cli/version.BuildTime=$(CLI_BUILDTIME)
CLI_LDFLAGS   += -X $(CLI_PKG)/cli/version.GitCommit=$(CLI_GITCOMMIT)
CLI_LDFLAGS   += -X $(CLI_PKG)/cli/version.Version=$(DOCKER_VERSION)
ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el))
CLI_BUILDMODE := -buildmode=pie
endif

# engine: have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs
# (we clean it up appropriately ourselves)
ENGINE_KEEPBUNDLE := 1

ENGINE_BUILDTAGS := apparmor seccomp
ENGINE_TESTFLAGS := -test.short

BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

%:
	dh $@ --buildsystem=golang --with=bash-completion,golang --builddirectory=_build

override_dh_golang:
## Set DH_GOLANG_BUILDPKG so that Built-Using is properly generated.
	DH_GOLANG_BUILDPKG="$(CLI_PKG)/... $(ENGINE_PKG)/... $(LIBNETWORK_PKG)/... $(SWARMKIT_PKG)/..." \
	  dh_golang -O--buildsystem=golang -O--builddirectory=_build

override_dh_clean:
	dh_clean
	$(RM) -v -r autogen bundles man/man*/
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say grep { $$_=q{ */}.$$_ } split(/\s+/,$$1) if m{^Files\-Excluded:\s*(.*?)(?:\n\n|^Files|^Comment:)}sm;' debian/copyright`
	-find */vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
## dh_auto_configure symlinks dirs from "/usr/share/gocode/src" into
## $(GOPATH) unless folders already exist there in which case files
## are copied. Pre-making directories allows us to use debhelper to
## create proper GOPATH source tree yet have certain directories writable
## even if they are provided by already installed package.
	mkdir -pv $(GOPATH)/src/$(CLI_PKG)
	mkdir -pv $(GOPATH)/src/$(ENGINE_PKG)
	mkdir -pv $(GOPATH)/src/$(LIBNETWORK_PKG)
	mkdir -pv $(GOPATH)/src/$(SWARMKIT_PKG)

## Prepare builddirectory but throw away sourcedirectory.
	DH_GOPKG="__IGNORE__" dh_auto_configure

## Each package must be removed from working tree first, in case some
## of the packages that we are going to build are already installed.
## This is also useful for building in unclean environment.
##
## This is _necessary_ to avoid merging packages that we build with
## pre-installed packages. See #827226 for details.
## Debhelper knows only about "main" DH_GOPKG package but we build several
## and we have to ensure that build tree is properly prepared.
	$(RM) -r              $(GOPATH)/src/$(CLI_PKG)
	cp -ra  cli           $(GOPATH)/src/$(CLI_PKG)
	$(RM) -r              $(GOPATH)/src/$(ENGINE_PKG)
	cp -ra  engine        $(GOPATH)/src/$(ENGINE_PKG)
	$(RM) -r              $(GOPATH)/src/$(LIBNETWORK_PKG)
	cp -ra  libnetwork    $(GOPATH)/src/$(LIBNETWORK_PKG)
	$(RM) -r              $(GOPATH)/src/$(SWARMKIT_PKG)
	cp -ra  swarmkit      $(GOPATH)/src/$(SWARMKIT_PKG)

override_dh_auto_build:
## Order is important:

	DH_GOPKG=$(LIBNETWORK_PKG) dh_auto_build -v

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG=$(SWARMKIT_PKG) dh_auto_build -v

##	build ("cd" first to ensure we build from within GOPATH)
	cd $(GOPATH)/src/$(ENGINE_PKG) \
	&& KEEPBUNDLE=$(ENGINE_KEEPBUNDLE) VERSION=$(DOCKER_VERSION) DOCKER_BUILDTAGS='$(ENGINE_BUILDTAGS)' \
	   DOCKER_GITCOMMIT=$(ENGINE_GITCOMMIT) PRODUCT=docker ./hack/make.sh dynbinary

	DH_GOPKG=$(CLI_PKG) DH_GOLANG_BUILDPKG=$(CLI_PKG)/cmd/docker \
	  dh_auto_build -v -- -tags '$(CLI_BUILDTAGS)' -ldflags '$(CLI_LDFLAGS)' $(CLI_BUILDMODE)
	cd $(GOPATH)/src/$(CLI_PKG) && ./scripts/docs/generate-man.sh

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	## Test engine:
	cd $(GOPATH)/src/$(ENGINE_PKG) \
	&& TESTFLAGS='$(ENGINE_TESTFLAGS)' \
	   EXCLUDE_PATHS="|daemon/graphdriver/aufs" ./hack/test/unit

	## Test CLI:
	cd $(GOPATH)/src/$(CLI_PKG) \
	&& DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit
endif

override_dh_install:
	## Rename binaries
	cd $(GOPATH)/src/$(ENGINE_PKG)/bundles/dynbinary-daemon \
	&& mv dockerd-$(DOCKER_VERSION) dockerd
	cd $(GOPATH)/bin \
	&& mv proxy docker-proxy
	## Do not install extra license files:
	dh_install -XLICENSE

override_dh_auto_install:
	## skip dh_auto_install to stop dh_golang trying to copy bits
	## for /usr/share/gocode (we use dh_install for that)

override_dh_installinit:
	dh_installinit -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev -v --name=docker --priority=z80
